<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css"
    />
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
  </head>
  <body>
    <div class="container mt-4">
      <h2>Lucky Dice UserName</h2>
      <div class="form-group">
        <label for="username">User name:</label>
        <input
          type="email"
          class="form-control"
          id="user-name"
          placeholder="Enter username"
          name="username"
        />
      </div>
      <div class="form-group">
        <button
          type="button"
          class="btn btn-primary"
          onclick="onBtnShowDiceHistoryClick()"
        >
          Show Voucher History Table
        </button>
      </div>
      <div id="log-result" class="mt-5"></div>
      <div class="mt-5">
        <table
          id="table-dice-history"
          class="table table-striped table-bordered table-hover"
        >
          <thead>
            <tr>
              <th>Mã giảm giá</th>
              <th>Phần Trăm giảm giá</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gEND_OF_ROW_COL = -1;
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";
        const gCOL_MA_VOUCHER = 0;
        const gCOL_PHAN_TRAM_GIAM_GIA = 1;

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        //hàm xử lý sự kiện show dice
        function onBtnShowDiceHistoryClick() {
          //khai báo đối tượng
          var vUserObj = {
            username: "",
          };
          ///b1 thu thập dữ liệu
          thuThapDuLieu(vUserObj);
          //b2 validate
          var vDuLieuHopLe = kiemTraDuLieu(vUserObj);
          if (vDuLieuHopLe) {
            //b3 gọi api
            var vVoucherXmlHttp = new XMLHttpRequest();
            goiApiLayLichSU(vUserObj, vVoucherXmlHttp);
            vVoucherXmlHttp.onreadystatechange = function () {
              if (
                this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK &&
                this.status == gREQUEST_STATUS_OK
              ) {
                // var vPrizeHistory = vXmlHttpPrizeHistory.responseText;
                hienThiLichSu(vVoucherXmlHttp);
              }
            };
            //b4 hiển thị
          }
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        function thuThapDuLieu(paramOBj) {
          var vUserNameInput = document.getElementById("user-name");
          paramOBj.username = vUserNameInput.value.trim();
        }
  
        function kiemTraDuLieu(paramObj) {
          if ((paramObj.username == "")) {
            alert("Bạn cần nhập vào username");
            return false;
          }
          return true;
        }
  
        function goiApiLayLichSU(paramUserObj, paramXmlHttp) {
          paramXmlHttp.open(
            "GET",
            gBASE_URL + "/prize-history?username=" + paramUserObj.username,true);
          paramXmlHttp.send();
        }
  
        function hienThiLichSu(paramXmlHttp) {
        //   console.log(paramXmlHttp.responseText);
          var vPrizeHistory =  JSON.parse(paramXmlHttp.responseText)
          var vPrizerHistoryTable = document.getElementById("table-dice-history")
          var vPrizeHistoryTBody = vPrizerHistoryTable.getElementsByTagName("tbody")[0]
          //xóa trắng bảng
          vPrizeHistoryTBody.innerHTML = ""
          for(var bI =0; bI< vPrizeHistory.prizes.length;bI++){
          
             //thêm 1 dòng mới
            var bNewRow = vPrizeHistoryTBody.insertRow(gEND_OF_ROW_COL  )
             //thêm các ô trên dòng mới
            var bGameCell  = bNewRow.insertCell(0)
            var bPresentCell = bNewRow.insertCell(1)
             //điền dữ liệu cho từng ô
             bGameCell.innerHTML = bI+1;
             bPresentCell.innerHTML = vPrizeHistory.prizes[bI]
  
          }
        }
      </script>
  </body>
</html>
